package org.dromara.work.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.RequiredArgsConstructor;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.work.domain.TpIntegralDetail;
import org.dromara.work.domain.bo.TpIntegralDetailBo;
import org.dromara.work.domain.vo.TpIntegralDetailVo;
import org.dromara.work.mapper.TpIntegralDetailMapper;
import org.dromara.work.service.ITpIntegralDetailService;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 积分明细Service业务层处理
 *
 * @author Maosw
 * @date 2024-08-12
 */
@RequiredArgsConstructor
@Service
public class TpIntegralDetailServiceImpl implements ITpIntegralDetailService {

    private final TpIntegralDetailMapper baseMapper;

    /**
     * 查询积分明细
     *
     * @param id 主键
     * @return 积分明细
     */
    @Override
    public TpIntegralDetailVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询积分明细列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 积分明细分页列表
     */
    @Override
    public TableDataInfo<TpIntegralDetailVo> queryPageList(TpIntegralDetailBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<TpIntegralDetail> lqw = buildQueryWrapper(bo);
        Page<TpIntegralDetailVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的积分明细列表
     *
     * @param bo 查询条件
     * @return 积分明细列表
     */
    @Override
    public List<TpIntegralDetailVo> queryList(TpIntegralDetailBo bo) {
        LambdaQueryWrapper<TpIntegralDetail> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<TpIntegralDetail> buildQueryWrapper(TpIntegralDetailBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<TpIntegralDetail> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getUid() != null, TpIntegralDetail::getUid, bo.getUid());
        lqw.eq(StringUtils.isNotBlank(bo.getTitle()), TpIntegralDetail::getTitle, bo.getTitle());
        lqw.eq(bo.getType() != null, TpIntegralDetail::getType, bo.getType());
        lqw.eq(bo.getPrice() != null, TpIntegralDetail::getPrice, bo.getPrice());
        lqw.eq(bo.getAddTime() != null, TpIntegralDetail::getAddTime, bo.getAddTime());
        return lqw;
    }

    /**
     * 新增积分明细
     *
     * @param bo 积分明细
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(TpIntegralDetailBo bo) {
        TpIntegralDetail add = MapstructUtils.convert(bo, TpIntegralDetail.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改积分明细
     *
     * @param bo 积分明细
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(TpIntegralDetailBo bo) {
        TpIntegralDetail update = MapstructUtils.convert(bo, TpIntegralDetail.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(TpIntegralDetail entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除积分明细信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
